<?php
/*
	Plugin Name: Bin Event Calendar
	Plugin URI: https://berginformatik.ch/plugin/bin-event-calendar
	Description: Event Calendar and Agenda
	Version: 1.0.0
	Author: Berg Informatik
	Author URI: https://berginformatik.ch
	Text Domain: bin-event-calendar
	Domain Path: /languages
*/

if(!defined('ABSPATH')) { exit; }

define('BIN_EVENT_CALENDAR_VERSION', '1.0.0');
define('BIN_EVENT_CALENDAR_URL', plugins_url('', __FILE__));
define('BIN_EVENT_CALENDAR_DIR', dirname(__FILE__));
define('BIN_EVENT_CALENDAR_DEBUG', false);

// ext
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Component.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/ParameterBag.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/PropertyBag.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Component/Alarm.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Component/Calendar.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Component/Event.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Component/Timezone.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Component/TimezoneRule.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/ValueInterface.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/ArrayValue.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/DateTimeProperty.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/DateTimesProperty.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/StringValue.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/RawStringValue.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/Event/Attendees.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/Event/Geo.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/Event/Organizer.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/Event/RecurrenceId.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Property/Event/RecurrenceRule.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Util/ComponentUtil.php';
require_once BIN_EVENT_CALENDAR_DIR.'/ext/iCal-0.15.1/Util/DateUtil.php';

// load main class
require_once BIN_EVENT_CALENDAR_DIR.'/bin-event-calendar.main.php';

// module
require_once BIN_EVENT_CALENDAR_DIR.'/module/customposttype.php';
require_once BIN_EVENT_CALENDAR_DIR.'/module/taxonomy.php';
require_once BIN_EVENT_CALENDAR_DIR.'/module/dashboard.php';
require_once BIN_EVENT_CALENDAR_DIR.'/module/shortcode.php';

// On plugin activation
register_activation_hook(__FILE__, 'bin_event_calendar_activation');
function bin_event_calendar_activation()
{
	BinEventCalendar::activate();
}

// On plugin deactivation
register_deactivation_hook(__FILE__, 'bin_event_calendar_deactivation');
function bin_event_calendar_deactivation()
{
	BinEventCalendar::deactivate();
}

// On plugin remove
register_uninstall_hook(__FILE__, 'bin_event_calendar_uninstall');
function bin_event_calendar_uninstall()
{
	BinEventCalendar::uninstall();
}

// Run
add_action('plugins_loaded', 'initBinEventCalendar');
function initBinEventCalendar()
{	
	new BinEventCalendar;
	new BinEventCalendar_Customposttype;
	new BinEventCalendar_Taxonomy;
	new BinEventCalendar_Dashboard;
	new BinEventCalendar_Shortcode;
}