/**
 * Calendar widget
 */
jQuery(document).ready(function($)
{
	/**
	 * ajax load widget data
	 */
	$('#bin_event_calendar_widget').on('click', '.bin_event_calendar_ajax', function(e)
	{
		e.preventDefault();
		trigger = $(this);
		trigger.append('<div class="bin_event_calendar_ajax_spinner"></div>');
		
		$.post(ajaxurl, trigger.data('attributes'), function(response)
		{
			trigger.find('.bin_event_calendar_ajax_spinner').remove();
			$(trigger.data('target')).html(response);
		});
	});
	
	$('#bin_event_calendar_widget').on('click', '.bin_event_calendar_tooltip', function(e)
	{
		e.preventDefault();
		$(this).find('.bin_event_calendar_tooltip_text').show();
	});
	
	$('#bin_event_calendar_widget').on('click', '.bin_event_calendar_tooltip_text', function(e)
	{
		e.preventDefault();
		e.stopPropagation();
		$('#bin_event_calendar_widget').find('.bin_event_calendar_tooltip_text').hide();
	});
	
	$('#bin_event_calendar_widget').on('click', '.bin_event_calendar_tooltip_text a', function(e)
	{
		e.stopPropagation();
	});
});
	
/**
 * Form element conditional logic
 */
jQuery(document).ready(function($)
{
	dataCondition();
	function dataCondition()
	{
		$('[data-bin-event-calendar-condition]').each(function()
		{
			// initial show
			$input = $(this);
			$condition = $input.data('bin-event-calendar-condition').split(',');
			$parent = $input.data('bin-event-calendar-condition-parent');

			if(typeof $parent === 'undefined' || $('.'+$parent).is(':not(:hidden)'))
			{
				$.each($condition, function(index, value)
				{
					$data = value.split(':');
					if($input.val() === $data[0])
					{	
						$('.'+$data[1]).show();
					}
				});
			}

			// click function
			$(this).bind({
				change: function()
				{
					$input = $(this);
					$condition = $input.data('bin-event-calendar-condition').split(',');
					$parent = $input.data('bin-event-calendar-condition-parent');

					// hide all
					$.each($condition, function(index, value)
					{
						$data = value.split(':');
						$('.'+$data[1]).hide();	
					});

					// show clicked
					$.each($condition, function(index, value)
					{
						$data = value.split(':');

						if((typeof $parent === 'undefined' || $('.'+$parent).is(':not(:hidden)')) && $input.val() === $data[0])
						{
							console.log($input.val()+' '+$data[0]+' '+$data[1]);
							$('.'+$data[1]).show();	
						}
						
						$('[data-bin-event-calendar-condition-parent="'+$data[1]+'"]').trigger('change');
					});
				}
			});
		});
	}
});