<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class BinEventCalendar_Customposttype
{
	public function __construct()
	{
		// register custom post type
		add_action('init', [$this, 'init']);
		
		// extend custom post type
		add_action('add_meta_boxes_event', [$this, 'add_meta_boxes']);
		add_action('save_post_event', [$this, 'save_post_event']);
		
		// extend columns view
		add_filter('manage_edit-event_columns',  [$this, 'event_columns']);
		add_filter('manage_edit-event_sortable_columns', [$this, 'event_sortable_columns']);
		add_action('manage_posts_custom_column',  [$this, 'event_custom_column'], 10, 2);
	}
	
	function init()
	{
		register_post_type('event', [
			'labels' => [
				'name' => __('Events', 'bin-event-calendar'),
				'singular_name' => __('Event', 'bin-event-calendar'),
				'add_new_item' => __('Add new event', 'bin-event-calendar'),
				'edit_item' => __('Edit event', 'bin-event-calendar'),
				'new_item' => __('New event', 'bin-event-calendar'),
				'not_found' => __('No event found', 'bin-event-calendar'),
				'all_items' => __('All events', 'bin-event-calendar')
			],
			'public' => true,
			'exclude_from_search' => true,
			'publicly_queryable' => true,
			'show_ui' => true,
			'show_in_menu' => true,
			'show_in_rest' => true,
			'has_archive' => true,
			'map_meta_cap' => true,
			'menu_icon' => 'dashicons-calendar-alt',
			'supports' => ['title', 'editor', 'author', 'revisions', 'excerpt', 'thumbnail'],
			'taxonomies' => [],
			'rewrite' => ['slug' => 'event'],
		]);
	}
	
	function add_meta_boxes($post)
	{
		add_meta_box('bin_event_calendar_contact_metabox_event', __('Event data', 'bin-event-calendar'), [$this, 'bin_event_calendar_contact_metabox_event_build'], 'event', 'side', 'high');
	}
	
	function bin_event_calendar_contact_metabox_event_build($post)
	{
		// make sure the form request comes from WordPress
		wp_nonce_field(basename( __FILE__ ), 'bin_event_calendar_meta_box_nonce');

		echo '<div class="components-base-control">';
		
			echo '<div class="components-base-control__field">';
				echo '<label class="components-base-control__label" for="bin_event_calendar_event_duration">'.__('Duration', 'bin-event-calendar').'</label>';
				echo '<select id="bin_event_calendar_event_duration" name="bin_event_calendar_event_duration" class="components-select-control__input" data-bin-event-calendar-condition="one_day:js_bin_event_calendar_condition_hidden_one,several_days:js_bin_event_calendar_condition_hidden_serval">';
					foreach(BinEventCalendar::formEventDuration() as $key => $value)
					{
						echo '<option value="'.$key.'" '.selected(get_post_meta($post->ID, 'bin_event_calendar_event_duration', true), $key, false).'>'.$value.'</option>';
					}
				echo '</select>';
			echo '</div>';

			// date_one
			echo '<div class="js_bin_event_calendar_condition_hidden_one bin_event_calendar_condition_hidden">';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_one_date">'.__('Date', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_one_date" name="bin_event_calendar_event_one_date" class="components-text-control__input" type="date" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_one_date', true).'">';
				echo '</div>';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_one_date_time_from">'.__('Time from', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_one_date_time_from" name="bin_event_calendar_event_one_date_time_from" class="components-text-control__input" type="time" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_one_date_time_from', true).'">';
				echo '</div>';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_one_date_time_to">'.__('Time to', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_one_date_time_to" name="bin_event_calendar_event_one_date_time_to" class="components-text-control__input" type="time" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_one_date_time_to', true).'">';
				echo '</div>';
			echo '</div>';
			
			// date_serval
			echo '<div class="js_bin_event_calendar_condition_hidden_serval bin_event_calendar_condition_hidden">';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_serval_date_from">'.__('Date from', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_serval_date_from" name="bin_event_calendar_event_serval_date_from" class="components-text-control__input" type="date" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_serval_date_from', true).'">';
				echo '</div>';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_serval_date_from_time_from">'.__('Time from', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_serval_date_from_time_from" name="bin_event_calendar_event_serval_date_from_time_from" class="components-text-control__input" type="time" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_serval_date_from_time_from', true).'">';
				echo '</div>';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_serval_date_to">'.__('Date to', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_serval_date_to" name="bin_event_calendar_event_serval_date_to" class="components-text-control__input" type="date" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_serval_date_to', true).'">';
				echo '</div>';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_serval_date_to_time_to">'.__('Time to', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_serval_date_to_time_to" name="bin_event_calendar_event_serval_date_to_time_to" class="components-text-control__input" type="time" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_serval_date_to_time_to', true).'">';
				echo '</div>';
			echo '</div>';
			
			// place
			echo '<div>';
				echo '<div class="components-base-control__field">';
					echo '<label class="components-base-control__label" for="bin_event_calendar_event_place">'.__('Place', 'bin-event-calendar').'</label>';
					echo '<input id="bin_event_calendar_event_place" name="bin_event_calendar_event_place" class="components-text-control__input" type="text" value="'.get_post_meta($post->ID, 'bin_event_calendar_event_place', true).'">';
				echo '</div>';
			echo '</div>';
			
		echo '</div>';
	}
	
	/**
	 * Store custom field meta box data
	 *
	 * @param int $post_id The post ID.
	 * @link https://codex.wordpress.org/Plugin_API/Action_Reference/save_post
	 */
	function save_post_event($post_id)
	{
		// verify meta box nonce
		if(!isset($_POST['bin_event_calendar_meta_box_nonce']) || !wp_verify_nonce($_POST['bin_event_calendar_meta_box_nonce'], basename( __FILE__ ))) { return; }

		// return if autosave
		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) { return; }

		// Check the user's permissions.
		if(!current_user_can('edit_post', $post_id)) { return; }
		
		// store custom fields values
		if(isset($_POST['bin_event_calendar_event_duration'])) { update_post_meta($post_id, 'bin_event_calendar_event_duration', sanitize_text_field($_POST['bin_event_calendar_event_duration'])); }
		if(isset($_POST['bin_event_calendar_event_one_date'])) { update_post_meta($post_id, 'bin_event_calendar_event_one_date', sanitize_text_field($_POST['bin_event_calendar_event_one_date'])); }
		if(isset($_POST['bin_event_calendar_event_one_date_time_from'])) { update_post_meta($post_id, 'bin_event_calendar_event_one_date_time_from', sanitize_text_field($_POST['bin_event_calendar_event_one_date_time_from'])); }
		if(isset($_POST['bin_event_calendar_event_one_date_time_to'])) { update_post_meta($post_id, 'bin_event_calendar_event_one_date_time_to', sanitize_text_field($_POST['bin_event_calendar_event_one_date_time_to'])); }
		if(isset($_POST['bin_event_calendar_event_serval_date_from'])) { update_post_meta($post_id, 'bin_event_calendar_event_serval_date_from', sanitize_text_field($_POST['bin_event_calendar_event_serval_date_from'])); }
		if(isset($_POST['bin_event_calendar_event_serval_date_from_time_from'])) { update_post_meta($post_id, 'bin_event_calendar_event_serval_date_from_time_from', sanitize_text_field($_POST['bin_event_calendar_event_serval_date_from_time_from'])); }
		if(isset($_POST['bin_event_calendar_event_serval_date_to'])) { update_post_meta($post_id, 'bin_event_calendar_event_serval_date_to', sanitize_text_field($_POST['bin_event_calendar_event_serval_date_to'])); }
		if(isset($_POST['bin_event_calendar_event_serval_date_to_time_to'])) { update_post_meta($post_id, 'bin_event_calendar_event_serval_date_to_time_to', sanitize_text_field($_POST['bin_event_calendar_event_serval_date_to_time_to'])); }
		if(isset($_POST['bin_event_calendar_event_place'])) { update_post_meta($post_id, 'bin_event_calendar_event_place', sanitize_text_field($_POST['bin_event_calendar_event_place'])); }
	}
	
	function event_columns($columns)
	{
		return [
			'cb' => '<input type="checkbox" />',
			'title' => __('Title', 'bin-event-calendar'),
			'event_date' => __('Event date', 'bin-event-calendar'),
			'event_duration' => __('Event duration', 'bin-event-calendar'),
			'event_ics' => __('iCalendar', 'bin-event-calendar'),
			'date' => __('Publish date', 'bin-event-calendar')
		];
	}
	
	function event_sortable_columns( $columns )
	{
		$columns['event_date'] = 'event_date';
		$columns['event_duration'] = 'event_duration';
		return $columns;
	}

	function event_custom_column($column, $post_id)
	{
		if($column === 'event_date') { echo BinEventCalendar::formatEventDate($post_id); }
		if($column === 'event_duration') { echo BinEventCalendar::formEventDuration()[get_post_meta($post_id, 'bin_event_calendar_event_duration', true)]; }
		if($column === 'event_ics') { echo '<a href="'.get_site_url().'/event/ics?id='.$post_id.'" class="button">'.__('ics', 'bin-event-calendar').'</a>'; }
	}
}